function run() {
    // for each input agent, compute a calculated metric named 
    // "JavaScript|<agentname>:Bytes Remaining" as
    // that agent's "Total Bytes" - "Bytes in Use".
    var i=0;
    var agent2remainingBytes = {};
    for(i=0; i < bindings.length; i++) {
        var metric = bindings[i].ESEAttribute.attributeURL;
        var agent = bindings[i].ESEProcess.processURL;
        var value = bindings[i].timeslicedValue.value;
        // set to 0 if we haven't seen this agent yet
        if (agent2remainingBytes[agent] == null) {
            agent2remainingBytes[agent] = 0;
        }
        // somewhat hacky way to subtract, but I can't determine
        // the order in which I'll see data.
        if (metric == "GC Heap:Bytes Total") {
            agent2remainingBytes[agent] +=  value;
        } else {
            agent2remainingBytes[agent] -=  value;
        }
    }
    // now iterate found agents and report calculated metrics
    for (var agent in agent2remainingBytes) {
        var metricName = "JavaScript|"+agent+":Remaining Bytes";
        var value = agent2remainingBytes[agent];
        accumulatorFactory.getLongFluctuatingCounterDataAccumulator(
            metricName).ILongCounterDataAccumulator_setValue(value);        
    }

}

function getAgentRegex() {
    return ".*";
}
function getMetricRegex() {
    return "GC Heap.*";
}
